/* _dict.cc 14/08/1996 16.09.34 */
/* base64.cc 23/10/1997 17.15.58 */
/* buttongif.cc 12/12/1999 22.10.48 */
/* buttons.cc 12/12/1999 22.18.42 */
PUBLIC int BUTTONS_INFO::evalwidth (void);
PUBLIC BUTTONS_INFO::BUTTONS_INFO (void);
PUBLIC BUTTONS_INFO::~BUTTONS_INFO (void);
PUBLIC void BUTTONS_INFO::setbutinfo (int id,
	 const char *title,
	 const char *icon);
PUBLIC void BUTTONS_INFO::delbutinfo (void);
PUBLIC void BUTTONS_INFO::set (int _but_options, HELP_FILE&_helpfile);
PUBLIC void BUTTONS_INFO::addhelp (HELP_FILE&help, const char *title);
PUBLIC void BUTTONS_INFO::setup (int _y, int width);
PUBLIC void BUTTONS_INFO::setcursor (WINDOW *dialog, int button);
PUBLIC void BUTTONS_INFO::draw (WINDOW *dialog, int button);
PUBLIC void BUTTONS_INFO::gui_draw (void);
PUBLIC void BUTTONS_INFO::help (WINDOW *win);
PUBLIC MENU_STATUS BUTTONS_INFO::dokey (WINDOW *dialog,
	 int key,
	 int &selected,
	 int other_focus);
PUBLIC MENU_STATUS BUTTONS_INFO::bid2status (int id);
/* checkbox.cc 13/12/1999 21.53.08 */
PUBLIC FIELD_CHECK_RADIO::FIELD_CHECK_RADIO (const char *_prompt,
	 char &_var,
	 const char *_title);
PUBLIC FIELD_CHECK_RADIO::~FIELD_CHECK_RADIO (void);
PUBLIC void FIELD_CHECK_RADIO::restore (void);
PUBLIC void FIELD_CHECK_RADIO::reload (const char *dianame, int nof);
PUBLIC void FIELD_CHECK_RADIO::save (void);
PUBLIC void FIELD_CHECK_RADIO::setcursor (WINDOW *dialog);
PUBLIC void FIELD_CHECK_RADIO::drawtxt_check (WINDOW *dialog,
	 char openchar,
	 char closechar,
	 char selchar);
PUBLIC void FIELD_CHECK_RADIO::format_htmlkey (char *key, int nof);
PUBLIC FIELD_CHECK::FIELD_CHECK (const char *_prompt,
	 char &_var,
	 const char *_title);
PUBLIC void FIELD_CHECK::drawtxt (WINDOW *dialog);
PUBLIC void FIELD_CHECK::html_draw (int nof);
PUBLIC void FIELD_CHECK::gui_draw (int nof, int &);
PUBLIC void FIELD_CHECK::gui_get (int nof);
PUBLIC char FIELD_CHECK::getidprefix (void);
PUBLIC int FIELD_CHECK::html_validate (int nof);
PUBLIC void FIELD_CHECK::dokey (WINDOW *dialog, int key, FIELD_MSG&);
PUBLIC FIELD_CHECK *DIALOG::newf_chk (const char *prompt,
	 char &var,
	 const char *title);
PUBLIC FIELD_CHECK_MULTI::FIELD_CHECK_MULTI (const char *_prompt,
	 char &_var,
	 const char *_options[]);
PUBLIC void FIELD_CHECK_MULTI::drawtxt (WINDOW *dialog);
PUBLIC void FIELD_CHECK_MULTI::save (void);
PUBLIC void FIELD_CHECK_MULTI::restore (void);
PUBLIC void FIELD_CHECK_MULTI::reload (const char *dianame, int nof);
PUBLIC void FIELD_CHECK_MULTI::html_draw (int nof);
PUBLIC void FIELD_CHECK_MULTI::gui_draw (int nof, int &);
PUBLIC void FIELD_CHECK_MULTI::gui_get (int nof);
PUBLIC char FIELD_CHECK_MULTI::getidprefix (void);
PUBLIC int FIELD_CHECK_MULTI::html_validate (int nof);
PUBLIC void FIELD_CHECK_MULTI::dokey (WINDOW *dialog,
	 int key,
	 FIELD_MSG&);
PUBLIC FIELD_CHECK_MULTI *DIALOG::newf_chkm (const char *prompt,
	 char &var,
	 const char *title[]);
PUBLIC FIELD_CHECK_MULTI_COL::FIELD_CHECK_MULTI_COL (const char *_prompt,
	 char &_var,
	 const char *_options[]);
PUBLIC int FIELD_CHECK_MULTI_COL::getwidths (int tb[], int &);
PUBLIC void FIELD_CHECK_MULTI_COL::setwidths (int max_width, int tb[]);
PUBLIC void FIELD_CHECK_MULTI_COL::gui_draw (int nof, int &);
PUBLIC void FIELD_CHECK_MULTI_COL::html_draw (int nof);
PUBLIC void FIELD_CHECK_MULTI_COL::drawtxt (WINDOW *dialog);
PUBLIC FIELD_CHECK_MULTI *DIALOG::newf_chkm_col (const char *prompt,
	 char &var,
	 const char *title[]);
/* checklist.cc 30/09/1996 10.50.30 */
/* checklist1.cc 26/09/1996 13.54.12 */
/* chkmval.cc 13/12/1999 21.53.08 */
PUBLIC FIELD_CHECK_MULTI_VAL::FIELD_CHECK_MULTI_VAL (const char *_prompt,
	 int &_var,
	 const int _vals[],
	 const char *_options[],
	 bool _hexmode);
PRIVATE int FIELD_CHECK_MULTI_VAL::getcurval (void)const;
PUBLIC void FIELD_CHECK_MULTI_VAL::save (void);
PUBLIC void FIELD_CHECK_MULTI_VAL::restore (void);
PUBLIC void FIELD_CHECK_MULTI_VAL::reload (const char *dianame,
	 int nof);
PUBLIC void FIELD_CHECK_MULTI_VAL::drawtxt (WINDOW *dialog);
PUBLIC void FIELD_CHECK_MULTI_VAL::setcursor (WINDOW *dialog);
PUBLIC void FIELD_CHECK_MULTI_VAL::dokey (WINDOW *dialog,
	 int key,
	 FIELD_MSG&);
PUBLIC void FIELD_CHECK_MULTI_VAL::html_draw (int nof);
PUBLIC int FIELD_CHECK_MULTI_VAL::html_validate (int nof);
PUBLIC void FIELD_CHECK_MULTI_VAL::gui_draw (int nof, int &);
PUBLIC void FIELD_CHECK_MULTI_VAL::gui_get (int nof);
PUBLIC FIELD_CHECK_MULTI *DIALOG::newf_chkm_num (const char *prompt,
	 int &var,
	 const int vals[],
	 const char *options[]);
PUBLIC FIELD_CHECK_MULTI *DIALOG::newf_chkm_hexnum (const char *prompt,
	 int &var,
	 const int vals[],
	 const char *options[]);
/* cmdsock.cc 18/01/1999 16.04.42 */
PRIVATE void CMDSOCK::init (int port, int reuseadr);
PUBLIC CMDSOCK::CMDSOCK (const char *portname, int reuseaddr);
PUBLIC CMDSOCK::CMDSOCK (int port, int reuseaddr);
PUBLIC CMDSOCK::~CMDSOCK (void);
PUBLIC int CMDSOCK::is_ok (void);
PUBLIC void CMDSOCK::forgetcli (int fd);
PUBLIC void CMDSOCK::closecli (int fd);
PUBLIC void CMDSOCK::addcli (int fd, int timeout);
PUBLIC void CMDSOCK::addcli (int fd);
PUBLIC int CMDSOCK::listen (long timeout);
PUBLIC int CMDSOCK::getnbcli (void);
PUBLIC int CMDSOCK::readnext (void *buf, int size, int &cli);
/* def.cc 30/03/1996 00.21.00 */
/* diaetc.cc 22/07/1999 23.34.06 */
/* diagui.cc 19/12/1999 22.54.10 */
const char *DIALOG::setguiname (char tmp[200]);
PRIVATE void DIALOG::guidelete (void);
PRIVATE void DIALOG::showgui (int &nof, int but_options);
PRIVATE MENU_STATUS DIALOG::editgui_thread (int &nof, int but_options);
PRIVATE MENU_STATUS DIALOG::editgui (int &nof, int but_options);
/* dialist.cc 12/12/1999 22.22.16 */
PUBLIC DIALOG_RECORDS::DIALOG_RECORDS (void);
PUBLIC DIALOG_LISTE::DIALOG_LISTE (void);
PUBLIC DIALOG_LISTE::~DIALOG_LISTE (void);
PUBLIC void DIALOG_RECORDS::setkeyformat (bool tag_is_key);
PUBLIC MENU_STATUS DIALOG_RECORDS::editmenu (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 int &sel,
	 int options);
PUBLIC MENU_STATUS DIALOG_LISTE::editmenu (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 int &sel,
	 int options);
/* dialog.cc 19/12/1999 22.44.52 */
PUBLIC void DIALOG::save (void);
PUBLIC void DIALOG::restore (void);
PUBLIC void DIALOG::reload (int start, int end);
PUBLIC void DIALOG::reload (void);
PUBLIC void DIALOG::reload (int no);
PUBLIC void DIALOG::set_readonly (void);
PUBLIC void DIALOG::set_lastreadonly (void);
PUBLIC void DIALOG::last_noempty (void);
PUBLIC int DIALOG::was_modified (void);
PUBLIC FIELD *DIALOG::getitem (int no);
PUBLIC FIELD_MSG::FIELD_MSG (void);
PUBLIC void DIALOG::seticon (const char *_icon);
PUBLIC void DIALOG::setbutinfo (int id,
	 const char *title,
	 const char *icon);
PUBLIC void DIALOG::html_body (const char *ctl, ...);
PUBLIC void DIALOG::html_intro (const char *ctl, ...);
PUBLIC void DIALOG::html_top (const char *ctl, ...);
PUBLIC void DIALOG::html_end (const char *ctl, ...);
PUBLIC void DIALOG::set_alt_title (const char *_title);
PUBLIC void DIALOG::setsidetitle (const char *ctl, ...);
PUBLIC void DIALOG::setheight_hint (void);
PUBLIC void DIALOG::addhelp (HELP_FILE&help, const char *title);
PUBLIC void DIALOG::waitfor (const char *msg);
PUBLIC void DIALOG::settype (DIALOG_TYPE type);
/* fcombo.cc 13/12/1999 21.53.08 */
PUBLIC ELM_STR::ELM_STR (const char *_value, const char *_verbose);
PUBLIC ELM_STR::~ELM_STR (void);
PUBLIC ELM_STR *LIST_STR::getitem (int no);
PUBLIC const char *LIST_STR::getvalue (int no);
PUBLIC FIELD_COMBO::FIELD_COMBO (const char *_prompt, SSTRING&_str);
PUBLIC FIELD_LIST::FIELD_LIST (const char *_prompt, SSTRING&_str);
PUBLIC FIELD_COMBO::~FIELD_COMBO (void);
PUBLIC void FIELD_COMBO::addopt (const char *str);
PUBLIC void FIELD_COMBO::addopt (const char *value,
	 const char *verbose);
PROTECTED void FIELD_COMBO::assist (WINDOW *dialog);
PUBLIC void FIELD_COMBO::html_draw (int nof);
PUBLIC void FIELD_COMBO::gui_draw (int nof, int &);
PUBLIC void FIELD_COMBO::gui_get (int nof);
PUBLIC char FIELD_COMBO::getidprefix (void);
PUBLIC int FIELD_COMBO::html_validate (int nof);
PUBLIC FIELD_COMBO *DIALOG::newf_combo (const char *prompt,
	 SSTRING&str);
PUBLIC FIELD_LIST *DIALOG::newf_list (const char *prompt,
	 SSTRING&str);
PUBLIC VIRTUAL int FIELD_LIST::post_validate (void);
PUBLIC void FIELD_LIST::dokey (WINDOW *dialog, int , FIELD_MSG&);
PUBLIC FIELD_ENUM::FIELD_ENUM (const char *_prompt, int &_sel);
PUBLIC void FIELD_ENUM::restore (void);
PUBLIC void FIELD_ENUM::reload (const char *dianame, int nof);
PUBLIC void FIELD_ENUM::save (void);
PUBLIC void FIELD_ENUM::addopt (const char *str);
PUBLIC void FIELD_ENUM::addopt (const char *value,
	 const char *verbose);
PUBLIC FIELD_ENUM *DIALOG::newf_enum (const char *prompt, int &sel);
/* fcombom.cc 30/04/1998 16.42.36 */
PUBLIC ELM_STR_V::ELM_STR_V (const char *_str, char &_selected);
PUBLIC FIELD_COMBO_MANY::FIELD_COMBO_MANY (const char *_prompt,
	 SSTRING&_str);
PUBLIC void FIELD_COMBO_MANY::addopt (const char *str, char &selected);
PROTECTED void FIELD_COMBO_MANY::assist (WINDOW *dialog);
PUBLIC FIELD_COMBO_MANY *DIALOG::newf_combo_many (const char *prompt,
	 SSTRING&str);
/* field.cc 13/12/1999 21.53.08 */
PUBLIC FIELD::FIELD (const char *_prompt);
PUBLIC VIRTUAL FIELD::~FIELD (void);
PUBLIC VIRTUAL int FIELD::getnotepadlevel (void)const;
PUBLIC VIRTUAL void FIELD::set_noempty (void);
PUBLIC VIRTUAL void FIELD::set_selectable (bool _may_select);
PUBLIC VIRTUAL bool FIELD::is_selectable (void);
PUBLIC VIRTUAL bool FIELD::is_passthrough (void);
PUBLIC VIRTUAL int FIELD::post_validate (void);
PUBLIC bool FIELD::is_readonly (void);
PUBLIC void FIELD::set_readonly (void);
PROTECTED VIRTUAL void FIELD::processmsg (WINDOW *, FIELD_MSG&, int);
PROTECTED VIRTUAL int FIELD::getwidths (int [], int &);
PROTECTED VIRTUAL void FIELD::setwidths (int , int []);
PUBLIC VIRTUAL const char *FIELD::getmenustr (void)const;
PUBLIC VIRTUAL void FIELD::format_htmlkey (char *key, int nof);
PRIVATE void FIELD_STRING_BASE::init (int maxsiz);
PROTECTED FIELD_STRING_BASE::FIELD_STRING_BASE (const char *_prompt,
	 const char *_str,
	 int maxsiz);
PROTECTED FIELD_STRING_BASE::FIELD_STRING_BASE (const char *_prompt,
	 int maxsiz);
PUBLIC FIELD_STRING_BASE::~FIELD_STRING_BASE (void);
PUBLIC bool FIELD_STRING_BASE::is_empty (void);
PUBLIC int FIELD_STRING_BASE::post_validate (void);
PUBLIC FIELD_STRING::FIELD_STRING (const char *_prompt,
	 char *_str,
	 int maxsiz);
PUBLIC FIELD_STRING::~FIELD_STRING (void);
PUBLIC FIELD_PASSWORD::FIELD_PASSWORD (const char *_prompt,
	 SSTRING&_str);
PUBLIC void FIELD_STRING::save (void);
PUBLIC void FIELD_STRING::restore (void);
PROTECTED void FIELD::sendval (const char *dianame,
	 int nof,
	 char type,
	 const char *val);
PROTECTED void FIELD::sendval (const char *dianame,
	 int nof,
	 char type,
	 int val);
PUBLIC void FIELD_STRING::reload (const char *dianame, int nof);
PUBLIC void FIELD_STRING_BASE::drawtxt (WINDOW *dialog);
PUBLIC void FIELD_STRING_BASE::html_draw (int nof);
PUBLIC void FIELD_STRING_BASE::gui_draw (int nof, int &);
PUBLIC void FIELD_STRING_BASE::gui_get (int nof);
PUBLIC char FIELD_STRING_BASE::getidprefix (void);
PUBLIC int FIELD_STRING_BASE::html_validate (int nof);
PUBLIC void FIELD::draw (WINDOW *dialog);
PUBLIC VIRTUAL void FIELD::setcursor (WINDOW *dialog);
PUBLIC VIRTUAL void FIELD::unselect (WINDOW *);
PUBLIC void FIELD_STRING_BASE::setcursor (WINDOW *dialog);
PUBLIC void FIELD_STRING_BASE::dokey (WINDOW *dialog,
	 int key,
	 FIELD_MSG&);
PUBLIC FIELD_SSTRING::FIELD_SSTRING (const char *_prompt,
	 SSTRING&_str,
	 int field_width);
PUBLIC void FIELD_SSTRING::save (void);
PUBLIC void FIELD_SSTRING::restore (void);
PUBLIC void FIELD_SSTRING::reload (const char *dianame, int nof);
PUBLIC void FIELD_SSTRING::html_draw (int nof);
PUBLIC FIELD_STRING *DIALOG::newf_str (const char *prompt,
	 char *str,
	 int maxsiz);
PUBLIC void DIALOG::newf_info (const char *prompt, const char *str);
PUBLIC FIELD_SSTRING *DIALOG::newf_str (const char *prompt,
	 SSTRING&str);
PUBLIC FIELD_SSTRING *DIALOG::newf_str (const char *prompt,
	 SSTRING&str,
	 int width);
PUBLIC FIELD_PASSWORD *DIALOG::newf_pass (const char *prompt,
	 SSTRING&str);
/* fldnum.cc 13/12/1999 21.53.10 */
PUBLIC FIELD_NUM::FIELD_NUM (const char *_prompt,
	 double *_dblval,
	 int *_intval,
	 FLDNUM_TYPE _type,
	 int _nbdecimals);
PRIVATE bool FIELD_NUM::validchar (char car);
PROTECTED void FIELD_NUM::dokey (WINDOW *w, int key, FIELD_MSG&msg);
PUBLIC void FIELD_NUM::html_draw (int nof);
PUBLIC void FIELD_NUM::save (void);
PUBLIC void FIELD_NUM::restore (void);
PUBLIC void FIELD_NUM::reload (const char *dianame, int nof);
PUBLIC int FIELD_NUM::post_validate (void);
PUBLIC FIELD *DIALOG::newf_num (const char *prompt, int &val);
PUBLIC FIELD *DIALOG::newf_hexnum (const char *prompt, int &val);
PUBLIC FIELD *DIALOG::newf_octnum (const char *prompt, int &val);
PUBLIC FIELD *DIALOG::newf_dbl (const char *prompt,
	 double &val,
	 int nbdecimals);
PUBLIC FIELD_SLIDER::FIELD_SLIDER (const char *_prompt,
	 int &_val,
	 int _minval,
	 int _maxval);
PUBLIC void FIELD_SLIDER::gui_draw (int nof, int &level);
PUBLIC FIELD *DIALOG::newf_slider (const char *prompt,
	 int &val,
	 int minval,
	 int maxval);
PUBLIC FIELD_GAUGE::FIELD_GAUGE (const char *_prompt,
	 int &_val,
	 int _range);
PUBLIC void FIELD_GAUGE::drawtxt (WINDOW *dialog);
PUBLIC void FIELD_GAUGE::html_draw (int);
PUBLIC void FIELD_GAUGE::gui_draw (int nof, int &);
PUBLIC FIELD *DIALOG::newf_gauge (const char *prompt,
	 int &val,
	 int range);
/* fstrhelp.cc 20/02/1999 21.55.52 */
PUBLIC FIELD_STRING_HELP::FIELD_STRING_HELP (const char *_prompt,
	 SSTRING&_str);
PUBLIC void FIELD_STRING_HELP::drawtxt (WINDOW *dialog);
PUBLIC void FIELD_STRING_HELP::dokey (WINDOW *dialog,
	 int key,
	 FIELD_MSG&msg);
/* ftitle.cc 13/12/1999 21.53.10 */
PUBLIC FIELD_TITLE::FIELD_TITLE (const char *_pad,
	 int _level,
	 const char *_prompt,
	 const char *_str);
PUBLIC FIELD_TITLE::~FIELD_TITLE (void);
PUBLIC const char *FIELD_TITLE::getmenustr (void)const;
PUBLIC void FIELD_TITLE::drawtxt (WINDOW *win);
PUBLIC void FIELD_TITLE::html_draw (int);
PUBLIC void FIELD_TITLE::gui_draw (int nof, int &booklevel);
PUBLIC int FIELD_TITLE::getnotepadlevel (void)const;
PUBLIC int FIELD_TITLE::html_validate (int);
PUBLIC void DIALOG::newf_title (const char *pad,
	 int level,
	 const char *prompt,
	 const char *msg);
PUBLIC void DIALOG::newf_title (const char *prompt, const char *msg);
PUBLIC FIELD_HEAD::FIELD_HEAD (const char *_prompt,
	 const char *_msg,
	 bool _is_list);
PROTECTED int FIELD_HEAD::getwidths (int tb[], int &reset);
PUBLIC void FIELD_HEAD::setwidths (int total_width, int tb[]);
PUBLIC void FIELD_HEAD::drawtxt (WINDOW *win);
PUBLIC void FIELD_HEAD::html_draw (int);
PUBLIC void FIELD_HEAD::gui_draw (int , int &);
PUBLIC VIRTUAL void DIALOG::newf_head (const char *prompt,
	 const char *msg);
PUBLIC void DIALOG_RECORDS::newf_head (const char *prompt,
	 const char *msg);
/* html.cc 12/12/1999 22.10.48 */
PRIVATE void DIALOG::html_draw_top (void);
PRIVATE void DIALOG::html_draw_intro (void);
PRIVATE void DIALOG::html_draw_fields (int nof);
PRIVATE void DIALOG::html_draw_form (int nof);
PRIVATE void DIALOG::html_draw_end (void);
PRIVATE void DIALOG::html_draw (DIALOG *spc, int nof);
PRIVATE void DIALOG::html_draw (int nof);
PRIVATE int DIALOG::html_validate (void);
PUBLIC void BUTTONS_INFO::html_draw (void);
PRIVATE MENU_STATUS DIALOG::edithtml (int &nof);
/* inputbox.cc 10/01/1999 01.07.36 */
/* internal.cc 25/08/1997 22.28.58 */
/* isocnv.cc 06/09/1997 05.00.14 */
/* kbd.cc 04/02/1998 14.29.16 */
/* main.cc 26/09/1996 13.29.46 */
/* menubox.cc 19/12/1999 22.44.34 */
PUBLIC FIELD_MENU::FIELD_MENU (const char *_icon,
	 const char *_tag,
	 const char *_str);
PUBLIC FIELD_MENU::~FIELD_MENU (void);
PUBLIC void FIELD_MENU::format_htmlkey (char *key, int);
PUBLIC void FIELD_MENU::setwidths (int total_width, int tb[]);
PROTECTED int FIELD_MENU::getwidths (int tb[], int &);
PUBLIC const char *FIELD_MENU::getmenustr (void)const;
PROTECTED void FIELD_MENU::save (void);
PROTECTED void FIELD_MENU::restore (void);
PROTECTED void FIELD_MENU::dokey (WINDOW *, int , FIELD_MSG&);
PUBLIC void FIELD_MENU::drawgen (WINDOW *win, int selected);
PUBLIC void FIELD_MENU::unselect (WINDOW *dialog);
PUBLIC void FIELD_MENU::setcursor (WINDOW *dialog);
PUBLIC void FIELD_MENU::drawtxt (WINDOW *dialog);
PUBLIC void FIELD_MENU::html_draw (int nof);
PUBLIC void FIELD_MENU::gui_draw (int nof, int &);
PUBLIC int FIELD_MENU::html_validate (int);
PRIVATE void DIALOG::fixwidth1 (void);
PUBLIC void DIALOG::new_menuline (const char *icon,
	 const char *prompt1,
	 const char *prompt2,
	 bool may_select);
PUBLIC void DIALOG::new_menuitem (const char *prompt1,
	 const char *prompt2);
PUBLIC void DIALOG::new_menuitem (const char *icon,
	 const char *prompt1,
	 const char *prompt2);
PUBLIC void DIALOG::set_menuitem (int no,
	 const char *prompt1,
	 const char *prompt2);
PUBLIC void DIALOG::new_menuinfo (const char *prompt1,
	 const char *prompt2);
PUBLIC void DIALOG::new_menuitem (const char *prompt1,
	 const SSTRING&prompt2);
PUBLIC void DIALOG::new_menuitem (const SSTRING&prompt1,
	 const SSTRING&prompt2);
PRIVATE void DIALOG::new_menuitem_parse (const char *item1,
	 const char *item2);
PUBLIC void DIALOG::new_menuitems (const char *items[], int item_no);
PUBLIC void DIALOG::new_menuitems (const char *opt[]);
PUBLIC const char *DIALOG::getmenustr (int choice);
PUBLIC void DIALOG::savewhat (const char *help);
PUBLIC void DIALOG::delwhat (const char *help);
PUBLIC void DIALOG::inswhat (const char *help);
PUBLIC void DIALOG::addwhat (const char *help);
PUBLIC VIRTUAL MENU_STATUS DIALOG::editmenu (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 int &sel,
	 int options);
PUBLIC VIRTUAL MENU_STATUS DIALOG_MENU::editmenu (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 int &sel,
	 int options);
PUBLIC void DIALOG_MENU::setmenu (MENU_CONTEXT ctx);
/* msgbox.cc 13/12/1999 21.53.10 */
/* multi.cc 19/12/1999 22.53.04 */
PRIVATE void DIALOG::setup (void);
PRIVATE void DIALOG::setoffset (int newoff);
PROTECTED void DIALOG::drawf (WINDOW *dialog);
PRIVATE void DIALOG::processmsg (WINDOW *dialog, FIELD_MSG&msg);
PRIVATE void DIALOG::draw (WINDOW *dialog);
PRIVATE void DIALOG::drawarrow_if (WINDOW *win,
	 bool condition,
	 bool&flag,
	 bool top,
	 chtype carac);
PRIVATE void DIALOG::dokeyup (int &nof, WINDOW *dialog);
PRIVATE void DIALOG::dokeydown (int &nof, WINDOW *dialog);
PROTECTED VIRTUAL int DIALOG::keymove (WINDOW *dialog,
	 int key,
	 int &nof);
PRIVATE void DIALOG::skipprotect (int &nof,
	 int suggestkey,
	 WINDOW *dialog);
PUBLIC DIALOG::DIALOG (void);
PUBLIC DIALOG::~DIALOG (void);
PUBLIC void DIALOG::remove_all (void);
PUBLIC void DIALOG::setcontext (const char *s);
PROTECTED void DIALOG::add (FIELD *f);
PUBLIC int DIALOG::remove_del (int no);
PUBLIC void DIALOG::show (const char *_title,
	 const char *_intro,
	 HELP_FILE&helpfile,
	 int &nof,
	 int but_options);
PUBLIC MENU_STATUS DIALOG::edit (const char *_title,
	 const char *_intro,
	 HELP_FILE&helpfile,
	 int &nof,
	 int but_options);
PUBLIC MENU_STATUS DIALOG::edit (const char *_title,
	 const char *intro,
	 HELP_FILE&helpfile,
	 int &nof);
PUBLIC MENU_STATUS DIALOG::edit (const char *_title,
	 const char *intro,
	 HELP_FILE&helpfile);
/* pass.cc 13/12/1999 21.53.10 */
PUBLIC FIELD_PASSTHROUGH::FIELD_PASSTHROUGH (int _command,
	 const char *_args);
PUBLIC void FIELD_PASSTHROUGH::drawtxt (WINDOW *);
PUBLIC void FIELD_PASSTHROUGH::dokey (WINDOW *, int , FIELD_MSG&);
PUBLIC void FIELD_PASSTHROUGH::save (void);
PUBLIC void FIELD_PASSTHROUGH::restore (void);
PUBLIC void FIELD_PASSTHROUGH::reload (const char *, int);
PUBLIC void FIELD_PASSTHROUGH::html_draw (int);
PUBLIC void FIELD_PASSTHROUGH::gui_get (int);
PUBLIC char FIELD_PASSTHROUGH::getidprefix (void);
PUBLIC int FIELD_PASSTHROUGH::html_validate (int);
PUBLIC void FIELD_PASSTHROUGH::gui_draw (int , int &);
PUBLIC bool FIELD_PASSTHROUGH::is_passthrough (void);
PUBLIC void DIALOG::gui_passthrough (int command,
	 const char *args,
	 ...);
PUBLIC void DIALOG::gui_passthroughv (int command,
	 const char *args,
	 va_list list);
PUBLIC void DIALOG::newline (void);
/* radio.cc 20/09/1998 22.10.44 */
PUBLIC FIELD_RADIO::FIELD_RADIO (const char *_prompt,
	 char &_var,
	 char _instance_val,
	 const char *_title);
PUBLIC FIELD_RADIO::~FIELD_RADIO (void);
PUBLIC void FIELD_RADIO::drawtxt (WINDOW *dialog);
PRIVATE FIELD_RADIO *FIELD_RADIO::locate_key (char *key);
PUBLIC void FIELD_RADIO::html_draw (int);
PUBLIC void FIELD_RADIO::gui_draw (int , int &);
PUBLIC void FIELD_RADIO::gui_get (int);
PUBLIC char FIELD_RADIO::getidprefix (void);
PUBLIC int FIELD_RADIO::html_validate (int);
PUBLIC void FIELD_RADIO::dokey (WINDOW *, int key, FIELD_MSG&msg);
PROTECTED void FIELD_RADIO::processmsg (WINDOW *dialog,
	 FIELD_MSG&msg,
	 int drawok);
PUBLIC FIELD_RADIO *DIALOG::newf_radio (const char *prompt,
	 char &var,
	 char instance_val,
	 const char *title);
/* rc.cc 01/08/1996 00.00.04 */
/* sheet.cc 13/12/1999 21.53.10 */
PUBLIC FIELD_SHEET::FIELD_SHEET (const char *prompt,
	 const char *_titles[],
	 SSTRINGS&_rows);
PUBLIC void FIELD_SHEET::drawtxt (WINDOW *);
PUBLIC void FIELD_SHEET::dokey (WINDOW *, int , FIELD_MSG&);
PUBLIC void FIELD_SHEET::save (void);
PUBLIC void FIELD_SHEET::restore (void);
PUBLIC void FIELD_SHEET::reload (const char *, int);
PUBLIC void FIELD_SHEET::html_draw (int nof);
PUBLIC char FIELD_SHEET::getidprefix (void);
PUBLIC int FIELD_SHEET::html_validate (int nof);
PUBLIC void FIELD_SHEET::gui_draw (int nof, int &);
PUBLIC void FIELD_SHEET::gui_get (int nof);
PUBLIC void DIALOG::newf_sheet (const char *prompt,
	 const char *titles[],
	 SSTRINGS&tb);
/* term.cc 13/12/1999 21.53.10 */
PRIVATE void DIALOG::showtimeout (WINDOW *win);
PRIVATE void DIALOG::showterm (int nof, int but_options);
PRIVATE MENU_STATUS DIALOG::editterm (int &nof, int but_options);
/* textarea.cc 13/12/1999 21.53.10 */
PUBLIC FIELD_TEXTAREA::FIELD_TEXTAREA (const char *prompt,
	 SSTRING&_text,
	 int _width,
	 int height);
PUBLIC void FIELD_TEXTAREA::drawtxt (WINDOW *);
PUBLIC void FIELD_TEXTAREA::dokey (WINDOW *, int , FIELD_MSG&);
PUBLIC void FIELD_TEXTAREA::save (void);
PUBLIC void FIELD_TEXTAREA::restore (void);
PUBLIC void FIELD_TEXTAREA::reload (const char *dianame, int nof);
PROTECTED void FIELD_TEXTAREA::sendlines (void);
PUBLIC void FIELD_TEXTAREA::html_draw (int nofield);
PUBLIC void FIELD_TEXTAREA::gui_draw (int nofield, int &);
PUBLIC void FIELD_TEXTAREA::gui_get (int nofield);
PUBLIC char FIELD_TEXTAREA::getidprefix (void);
PUBLIC int FIELD_TEXTAREA::html_validate (int);
PUBLIC void DIALOG::newf_textarea (const char *prompt,
	 SSTRING&text,
	 int width,
	 int height);
/* textbox.cc 19/05/1999 23.51.00 */
PUBLIC FIELD_TEXTBOX::FIELD_TEXTBOX (const char *_prompt,
	 const char *_buf);
PUBLIC void FIELD_TEXTBOX::drawtxt (WINDOW *dialog);
PUBLIC void FIELD_TEXTBOX::html_draw (int);
PUBLIC int FIELD_TEXTBOX::html_validate (int);
PUBLIC void FIELD_TEXTBOX::gui_draw (int , int &);
PUBLIC DIALOG_TEXTBOX::DIALOG_TEXTBOX (void);
PROTECTED int DIALOG_TEXTBOX::keymove (WINDOW *dialog,
	 int key,
	 int &nof);
PUBLIC void DIALOG_TEXTBOX::newf_text (const char *prompt,
	 const char *buftab);
PUBLIC void DIALOG_TEXTBOX::newf_text (const char *,
	 const SSTRINGS&strs);
/* uithread.cc 16/11/1998 21.21.58 */
/* varval.cc 17/09/1996 10.06.04 */
PUBLIC HTML_VARVAL::HTML_VARVAL (const char *key);
PUBLIC void HTML_VARVAL::add (const char *var, const char *val);
PUBLIC int HTML_VARVAL::getnb (void);
PUBLIC const char *HTML_VARVAL::getval (const char *var, int &exist);
PUBLIC const char *HTML_VARVAL::getval (int no);
PUBLIC const char *HTML_VARVAL::getvar (int no);
PUBLIC int HTML_VARVAL::exist (const char *var);
PUBLIC const char *HTML_VARVAL::getcontext (void);
PUBLIC int HTML_VARVAL::getid (void);
/* yesno.cc 13/12/1999 21.53.10 */
